void currentEnvelope()
{
  static uint16_t attackVolume = 0;
  static unsigned int lastVolume = 0;
  static unsigned int releaseVolume = 0;
  if (envelopeTrigger)
  {
    envelopeProgress = 255;
    if (envelopeVolume > 10)
      envelopeVolume -= 9; // we need to do this to prevent clicking
    else
    {
      envelopeTrigger = false;
      attackStartTime = millis();
      envelopeProgress = 0;
      attackVolume = lastVolume;
      for (byte i = 0; i < 4; i++)
      {
        if (muteVoice[i])
        {
          voiceSounding[i] = false;
          muteVoice[i] = false;
        }
      }
      assignVoices();
    }
  }
  switch (envelopeProgress)
  {
    case 0: // attack
      if ((millis() - attackStartTime) > attackTime)
      {
        envelopeProgress = 1;
        decayStartTime = millis();
      }
      else
      {
        envelopeVolume = map(millis(), attackStartTime, attackStartTime + attackTime, 0, 1023);
        lastVolume = envelopeVolume;
        releaseVolume = envelopeVolume;
        envOsc1Pitch = (envelopeVolume * envOsc1PitchFactor) << 4;
        envOsc2Pitch = (envelopeVolume * envOsc2PitchFactor) << 4;
        envFilterCutoff = (envelopeVolume * envFilterCutoffFactor) >> 12;
        if (envLfoRate > 10)
          lfoRate = map(envelopeVolume, 0, 1023, envLfoRate, userLfoRate);
      }
      break;
    case 1: // decay
      if ((millis() - decayStartTime) > decayTime)
      {
        envelopeProgress = 2;
      }
      else
      {
        envelopeVolume = map(millis(), decayStartTime, decayStartTime + decayTime, 1023, sustainLevel);
        lastVolume = envelopeVolume;
        releaseVolume = envelopeVolume;
        envOsc1Pitch = (envelopeVolume * envOsc1PitchFactor) << 4;
        envOsc2Pitch = (envelopeVolume * envOsc2PitchFactor) << 4;
        envFilterCutoff = (envelopeVolume * envFilterCutoffFactor) >> 12;
        if (envLfoRate > 10)
          lfoRate = map(envelopeVolume, 0, 1023, envLfoRate, userLfoRate);
      }
      break;
    case 2: // sustain
      envelopeVolume = sustainLevel;
      lastVolume = sustainLevel;
      releaseVolume = envelopeVolume;
      envOsc1Pitch = (envelopeVolume * envOsc1PitchFactor) << 4;
      envOsc2Pitch = (envelopeVolume * envOsc2PitchFactor) << 4;
      envFilterCutoff = (envelopeVolume * envFilterCutoffFactor) >> 12;
      if (envLfoRate > 10)
        lfoRate = map(envelopeVolume, 0, 1023, envLfoRate, userLfoRate);
      break;
    case 3: // release
      if ((millis() - releaseStartTime) > releaseTime)
      {
        envelopeProgress = 255;
        lastVolume = 0; // just make sure it's actually at zero
        for (byte i = 0; i < 4; i++)
          voiceSounding[i] = false; // none of the voices are sounding
      }
      else
      {
        if (envelopeVolume > 0)
        {
          envelopeVolume = map(millis(), releaseStartTime, releaseStartTime + releaseTime, releaseVolume, 0);
          envOsc1Pitch = (envelopeVolume * envOsc1PitchFactor) << 4;
          envOsc2Pitch = (envelopeVolume * envOsc2PitchFactor) << 4;
          envFilterCutoff = (envelopeVolume * envFilterCutoffFactor) >> 12;
          if (envLfoRate > 10)
            lfoRate = map(envelopeVolume, 0, 1023, envLfoRate, userLfoRate);
        }
        else
        {
          envelopeVolume = 0;
          envOsc1Pitch = 0;
          envOsc2Pitch = 0;
          lfoRate = userLfoRate;
        }
        lastVolume = envelopeVolume;
      }
      break;
    case 255: // the envelope is idle
      break;
  }
}
