void HandleNoteOn(byte channel, byte note, byte velocity)
{
  if (!midiMode)
  {
    midiMode = true; // switch to listening to notes from incoming MIDI
    envelopeProgress = 255;
    for (byte j = 0; j < 4; j++)
      voice[j] = 255;
  }

  if (!monoMode) // 4 voice paraphonic mode
  {
    voiceCounter = 0;
    for (byte i = 0; i < 4 ; i ++)
    {
      if (voice[i] != 255)
        voiceCounter++;
    }

    if (velocity == 0 && voiceCounter != 0)
    {
      // This acts like a NoteOff. You can ask the library to call the NoteOff
      // callback when receiving null-velocity NoteOn messages.
      // See MIDI_HANDLE_NULL_VELOCITY_NOTE_ON_AS_NOTE_OFF in midi_Settings.h
      //showPitch = pitch;
      //showVelocity = velocity;
      for (byte i = 0; i < 4; i++)
      {
        if (voice[i] == note - 60)
        {
          voice[i] = 255;
          voiceCounter--;
        }
      }
      if (voiceCounter == 0)
      {
        envelopeProgress = 3; // we're in release phase
        releaseStartTime = millis();
      }
    }
    else
    {
      if (voiceCounter < 4)
      {
        byte j = 0;
        while (voice[j] != 255 && j < 4) // go to the next voice if this voice isn't free
          j++;
        if (j < 4)
        {
          voice[j] = note - 60;
          //showValue(13, 1, voice[j]);
          envelopeTrigger = true;
          if (retrigger) // should we retrigger the LFO?
            lfoIndex = 0;
          if (voiceCounter == 0)
          {
            //voiceCounter++;
            for (byte k = 0; k < 4; k++)
            {
              if (k != j)
                muteVoice[k] = true;
            }
          }
          voiceCounter++;
        }
      }
    }
  }
  else // we're in modo mode
  {
    if (velocity != 0)
    {
      for (byte i = 0; i < 4; i++)
        voice[i] = note - 60;
      if (envelopeProgress > 2) // we're in envelope decay phase (3), or envelope is at rest (255)
      {
        envelopeTrigger = true;
        if (retrigger) // should we retrigger the LFO?
          lfoIndex = 0;
      }
    }
  }
}

void HandleNoteOff(byte channel, byte note, byte velocity)
{
  if (!monoMode) // we're in 4-voice paraphonic mode
  {
    voiceCounter = 0;
    for (byte i = 0; i < 4 ; i ++)
    {
      if (voice[i] != 255)
        voiceCounter++;
    }

    for (byte i = 0; i < 4; i++)
    {
      if (voice[i] == note - 60)
      {
        voice[i] = 255;
        voiceCounter--;
      }
    }
    if (voiceCounter == 0)
    {
      envelopeProgress = 3; // we're in release phase
      releaseStartTime = millis();
    }
    //showValue(13, 1, voiceCounter);
  }
  else // we are in mono mode
  {
    if (note - 60 == voice[0]) // in mono mode all 4 voices are the same, so we only have to compare against voice[0]
    {
      envelopeProgress = 3; // we're in release phase
      releaseStartTime = millis();
    }
  }
}

void HandleCC(byte channel, byte number, byte value)
{
  if (number == 2) // breath data received
  {
    if (!monoMode)
    {
    monoMode = true;
    lastFilterCutoff = filterCutoff;
    }
    filterCutoff = value << 1; // change range 0 - 127 to 0 - 255
  }
  midiCC[number] = value;
}
