void setup() {
  // TEMP
  //Serial.begin(9600);

  // *** LCD ***
  // set up the LCD's number of columns and rows:
  lcd.begin(16, 2);


  // create custom characters
/*
  lcd.createChar(0, arrow1);
  lcd.createChar(1, arrow2);
  lcd.createChar(2, arrow3);
  lcd.createChar(3, arrow4);
*/  
  lcd.createChar(2, Tee1);
  lcd.createChar(3, Tee2);
  lcd.createChar(4, Bee1);
  lcd.createChar(5, Bee2);
  lcd.createChar(6, Two1);
  lcd.createChar(7, Two2);

 lcd.setCursor(4, 0);
  lcd.print("Groovesizer");
  lcd.setCursor(4, 1);
  lcd.print("Ver.");
  lcd.setCursor(8, 1);
  lcd.print(versionNumber);  
  showTB2(0);
  
  // *** BUTTONS ***
  // Make input & enable pull-up resistors on switch pins
  for (byte i = 0; i < NUMBUTTONS; i ++)
    pinMode(buttons[i], INPUT_PULLUP);

  // *** POTS ***
  getPots();
  lockPot(5);

  // *** LED ***
  pinMode(LED, OUTPUT);
  digitalWrite(LED, LOW); // turn off the LED

  // *** SYNTH ***
  ulInput[0] = 512;

  createNoteTable(SAMPLE_RATE);
  createSineTable();
  createSquareTable(pulseWidth);
  createSawTable();
  createTriangleTable();
  clearUserTables();

  for (byte i = 0; i < 4; i++)
    wavePointer[i] = &nTriangleTable[0];
  for (byte i = 0; i < 4; i++)
    wavePointer[i + 4] = &nTriangleTable[0];

  // start the audio interrupt at 44.1kHz
  Timer3.attachInterrupt(AudioHandler).setFrequency(44100).start();
  Timer4.attachInterrupt(lfoHandler).setFrequency(22000).start();

  // this is a cheat - enable the DAC
  analogWrite(DAC0, 0);
  analogWrite(DAC1, 0);

  // *** FILTER ***
  setFilterCutoff(255);
  setFilterResonance(210);
  filterType(0); // 0 = LP, 1 = BP, 2 = HP

  // *** MIDI ***
  midiA.setHandleNoteOn(HandleNoteOn);  // these callback functions are defined in MIDI
  midiA.setHandleNoteOff(HandleNoteOff);
  midiA.setHandleControlChange(HandleCC);
  midiA.begin(MIDI_CHANNEL_OMNI);

  // *** SD CARD ***
  if (!sd.begin(chipSelect, SPI_FULL_SPEED))
  {
    lcd.setCursor(0, 1);
    lcd.print("*SD Unavailable*");
  }
  else
  getFirstFile();
  
  // clear the patch buffer
  for (uint16_t i = 0; i < 1900; i++)
    patchBuffer[i] = 0;
}
